package
{
	import flash.display.DisplayObject;
	import flash.display.GradientType;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.Matrix;
	import flash.text.TextField;
	import flash.utils.Timer;
	
	import mx.containers.Canvas;
	import mx.controls.Alert;
	import mx.controls.Label;
	import mx.core.Application;
	import mx.core.ScrollPolicy;
	import mx.core.UIComponent;
	import mx.events.ResizeEvent;

	public class TimeLine extends Canvas
	{
		private var pointerCurTime:UIComponent;		//当前时间竖线
		private var pointerRealTime:UIComponent;	//实时时间竖线
		private var lblCurTime:Label;			//当前时间文本提示
		private var lblRealTime:Label;			//实时时间文本提示
		
		private var maskLayer:Canvas;		//用于感应鼠标移动的层
		private var tipsDlg:TipsDialog;		//提示信息
		
		private var timer:Timer;					//用于定时刷新实时时间的定时器		
		
		private var isTipsDlgVisible:Boolean;	//是否允许显示TipsDlg
		private var isInMaskArea:Boolean;		//是否在maskLayer区域
		
		private var periods:Array;					//{start:startTime, end:endTime}时间段数组
		private var backgroundColor:uint = 0xFF0000;		//默认背景色
		private var foregroundColor:uint = 0x0000FF;		//默认前景色
		
		private var latestXBeforeMaskOut:Number;
		
		public function TimeLine()
		{
			this.createPointers();			//创建时间轴上的指示竖线线
	
			this.timer = new Timer(1000);
			this.timer.addEventListener(TimerEvent.TIMER, onTimer);
			this.timer.start();

			this.lblCurTime = new Label();
			this.lblCurTime.setStyle("textAlign", "center");
			this.lblCurTime.setStyle("color", 0xFF0000);
			this.lblCurTime.x = 0;
			this.lblCurTime.y = -3;
			this.lblCurTime.width = 38;
			this.addChild(this.lblCurTime);

			this.lblRealTime = new Label();
			this.lblRealTime.setStyle("textAlign", "center");
			this.lblRealTime.setStyle("color", 0x0000FF);
			this.lblRealTime.x = 0;
			this.lblRealTime.y = -3;
			this.addChild(this.lblRealTime);			
			
			
			this.maskLayer = new Canvas();
			
			this.addEventListener(ResizeEvent.RESIZE, onResize);
			this.maskLayer.addEventListener(MouseEvent.MOUSE_MOVE, onMaskMouseMove);
			this.maskLayer.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
			this.maskLayer.addEventListener(MouseEvent.MOUSE_OUT, onMaskMouseOut);			
			Application.application.parent.addEventListener(MouseEvent.MOUSE_MOVE, onSMMouseMove);

			this.addChild(this.maskLayer);
			this.horizontalScrollPolicy = ScrollPolicy.OFF;
			this.verticalScrollPolicy = ScrollPolicy.OFF;
			
			this.tipsDlg = new TipsDialog(90, 35);
			this.tipsDlg.visible = false;
			
			Application.application.parent.addChild(this.tipsDlg);
			
 			this.getPeriods("01:00-02:30,05:00-09:00,12:00-18:00");
		}
		
		//供JavaScript调用的用于设置背景色、前景色和时间段参数的方法
		public function getParamsFromJS(param:Object):void
		{
			var msgType:String = param.type;
			var msgValue:String = param.value;
			
			switch(msgType)
			{
				case "SETBGCOLOR":
					this.backgroundColor = parseInt(msgValue);
					this.draw();
					break;
					
				case "SETFOCOLOR":
					this.foregroundColor = parseInt(msgValue);
					this.draw();
					break;
					
				case "SETPERIODS":
					this.getPeriods(msgValue);
					this.draw();
					break;
					
				default:
					break;
			}
		}		
		
		private function onMouseOver(event:MouseEvent):void
		{
			this.isInMaskArea = true;
		}
		
		private function onSMMouseMove(event:MouseEvent):void
		{
			this.isTipsDlgVisible = false;
			this.tipsDlg.visible = false;
		}
		
		private function onMaskMouseOut(event:MouseEvent):void
		{
			this.isInMaskArea = false;
			this.isTipsDlgVisible = false;
			
/* 			trace(event.stageX);
			trace(event.localX);
			trace(event.target);
			 */
			 //if(event.target == this.maskLayer)
			 //trace(event.localY);
			/*  trace("latestXBeforeMaskOut:" + this.latestXBeforeMaskOut);
 			if(event.localX <= 0 && this.latestXBeforeMaskOut < this.maskLayer.width/2)
			{
				this.lblCurTime.x = 0;
				this.lblCurTime.text = "00:00";
				this.pointerCurTime.x = 0;
			}
			if(event.localX >= this.maskLayer.width-1 && this.latestXBeforeMaskOut > this.maskLayer.width/2)
			{
				this.lblCurTime.x = 100;//this.maskLayer.width - this.lblCurTime.width;
				this.lblCurTime.text = "23:59";
				this.pointerCurTime.x = this.maskLayer.width -1;
			} */
		}
		
		//网页上的参数
		private function getPeriods(param:String):void
		{
			try
			{
				this.periods = null;
				this.periods = new Array();
				
				var periodsArr:Array = param.split(",");
				
				for each(var str:Object in periodsArr)
				{
					var times:Array = (str as String).split("-");
					
					var startTime:Date = this.getDateByHHMM(times[0].toString());
					var endTime:Date = this.getDateByHHMM(times[1].toString());
					
					var obj:Object = new Object();
					obj.startTime = startTime;
					obj.endTime = endTime;
					
					obj.startMinutes = this.getMinutes(obj.startTime);
					obj.endMinutes = this.getMinutes(obj.endTime);
					
					this.periods.push(obj);
				}
			}
			catch(ex:Error)
			{
				Alert.show("参数有误!", "Error");
			}
		}
		
		private function onMaskMouseMove(event:MouseEvent):void
		{
			if(event.localY >= 45)
			{
				return;
			}
			
			this.pointerCurTime.x = event.localX;
			this.lblCurTime.x = event.localX - this.lblCurTime.width / 2+1;
			
			if(event.stageX < this.lblCurTime.width)
			{
				this.lblCurTime.x = 0;
			}
			
			//在最右侧
			if( (this.maskLayer.width - event.stageX) < this.lblCurTime.width)
			{
				this.lblCurTime.x = this.maskLayer.width - this.lblCurTime.width;
			}
			
			this.lblCurTime.text = this.getHHMMByX(event.localX);
			
			if(event.stageX >= this.maskLayer.width-1)
			{
				this.lblCurTime.text = "23:59";
			}
			this.latestXBeforeMaskOut = event.localX;
			event.updateAfterEvent();
		}
		
		private function onTimer(event:TimerEvent):void
		{
			var curTime:Date = new Date();
			
			this.pointerRealTime.x = this.getXByTime(curTime);
			
			this.lblRealTime.text = this.getHHMMByDate(curTime);//this.getHHMMByDate(new Date());//this.getHHMMByX(this.pointerRealTime.x);
			
			this.lblRealTime.x = this.pointerRealTime.x - this.lblRealTime.width/2+1
			
			if(!this.isTipsDlgVisible)
			{
				if(this.isInMaskArea)
				{
					this.isTipsDlgVisible = true;
				}
			}
			else
			{
				this.tipsDlg.visible = true;
				this.tipsDlg.x = this.stage.mouseX - this.tipsDlg.width/2;
				this.tipsDlg.y = this.stage.mouseY - this.tipsDlg.height - 5;
				this.tipsDlg.setTips(this.lblCurTime.text, this.getInfoByTimePoint(this.getDateByHHMM(this.lblCurTime.text)));
			}
		}
		
		//获取莫个时间点上的TipsDialog信息
		private function getInfoByTimePoint(timePoint:Date):String
		{
			var minus:int = this.getMinutes(timePoint);
			//排序
			this.periods.sortOn("startMinutes", Array.NUMERIC);
			
			for each(var obj:Object in this.periods)
			{
				if(minus >= obj.startMinutes && minus <= obj.endMinutes)
				{
					return this.getHHMMByDate(obj.startTime) + "-" + this.getHHMMByDate(obj.endTime) + " 运行";
				}
			}
			
			var leftObj:Object = null;
			var rightObj:Object = null;
			var tempObj:Object = null;
			
			var i:int=0;			
			for(; i<this.periods.length; ++i)
			{
				tempObj = this.periods[i];
				
				if(tempObj.startMinutes > minus)
				{
					rightObj = tempObj;
					break;
				}
			}
			
			leftObj = i>0 ? this.periods[i-1] : null;
			
			if(rightObj !=null && leftObj != null)
			{
				return this.getHHMMByDate(leftObj.endTime) + "-" +this.getHHMMByDate(rightObj.startTime) + " 待机";
			}
			if(rightObj != null && leftObj == null)
			{
				return "00:00-" + this.getHHMMByDate(rightObj.startTime) + " 待机";
			}
			if(rightObj == null && leftObj != null)
			{
				return  this.getHHMMByDate(leftObj.endTime) + "-23:59 待机";
			}
			
			return "";
		}
		
		private function getHHMMByDate(date:Date):String
		{
			var strHours:String = date.hours>9?date.hours.toString():"0"+date.hours.toString();
			var strMinutes:String = date.minutes>9?date.minutes.toString() : "0" + date.minutes.toString();
			return strHours + ":"+strMinutes;
		}
		
		//获取指定的个时间点和当天00:00的分钟数之差
		private function getMinutes(date:Date):int
		{
			return date.hours*60 + date.minutes;
		}
		
		private function getHHMMByX(x:Number):String
		{
			var totalMinutes:Number = 1440*(x-1)/this.width;
			totalMinutes = Math.floor(totalMinutes);
			//trace(totalMinutes);
			var hours:int = totalMinutes / 60;
			var minutes:int = totalMinutes % 60;
			var strH:String = hours>9? hours.toString() : "0" + hours.toString();
			var strM:String = minutes>9? minutes.toString() : "0" + minutes.toString();
			return strH + ":" + strM;
		}
		
		//根据指定的时间获取当前宽度的时间带上对应的x轴坐标
 		private function getXByTime(date:Date):Number
		{
			var totalMinutes:int = date.hours*60 + date.minutes;
			return totalMinutes * this.width / 1440;
		}
		
		//根据HH:MM格式的时间文本获取Date对象
		private function getDateByHHMM(hhmm:String):Date
		{
			var array:Array = hhmm.split(":");
			var hours:int = parseInt(array[0].toString());
			var minutes:int = parseInt(array[1].toString());
			var date:Date = new Date();
			date.setHours(hours, minutes, 0, 0);
			return date;
		}
		
		//创建时间轴上的指示线
		private function createPointers():void
		{
			this.pointerRealTime = new UIComponent();
			this.pointerRealTime.y = 10;
			this.pointerRealTime.width = 1;
			this.pointerRealTime.height = this.height;
			this.pointerRealTime.graphics.beginFill(0x0000FF, 1);
			this.pointerRealTime.graphics.drawRect(0, 0, 1, 34);

			this.addChild(this.pointerRealTime);
			
			this.pointerCurTime = new UIComponent();
			this.pointerCurTime.y = 10;
			this.pointerCurTime.width = 1;
			this.pointerCurTime.height = this.height;
			
			this.pointerCurTime.graphics.beginFill(0xFF0000, 1);
			this.pointerCurTime.graphics.drawRect(0, 0, 2, 34);
			
			this.addChild(this.pointerCurTime);
		}
		
		//改变大小时重画
		private function onResize(event:ResizeEvent):void
		{
			this.draw();
			this.maskLayer.width = this.width;
			this.maskLayer.height = this.height;
			
			this.pointerRealTime.x = this.getXByTime(new Date());
			this.lblRealTime.text = this.getHHMMByDate(new Date());//this.getHHMMByX(this.pointerRealTime.x);
			this.lblRealTime.x = this.pointerRealTime.x - 18;//this.lblRealTime.width/2;
			
			if(this.lblCurTime.text.length != 0)
			{
				var date:Date = this.getDateByHHMM(this.lblCurTime.text);
				this.pointerCurTime.x = this.getXByTime(date);
				this.lblCurTime.x = this.pointerCurTime.x - this.lblRealTime.width/2;
			}
			
			this.setChildIndex(this.maskLayer, this.numChildren-1);
		}
		
		//计算一个时间段在x轴上的长度
		private function calcPeriodLen(obj:Object):Number
		{
			return this.getXByTime(obj.endTime) - this.getXByTime(obj.startTime);
		}
		
		//根据待机/运行状态画背景色
		private function setBGByPeriods():void
		{
			var fillType:String = GradientType.LINEAR;
			var colors:Array = [this.backgroundColor,0xFFFFFF, this.backgroundColor];
			var alphas:Array = [0.8, 0.8, 0.8];
			var ratios:Array = [0, 127, 255];
			var matr:Matrix = new Matrix();
			matr.createGradientBox(this.height-10-20, (this.height-18), 90/180*Math.PI, 0, 0);  
			
			//画待机状态背景色
			this.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr);			
			this.graphics.drawRect(0, 10, this.width, this.height - 10 -20);
			this.graphics.endFill();
			
			if(this.periods == null) 
			{
				return;
			}
			//画运行状态背景色
			var newColors:Array = [this.foregroundColor,0xFFFFFF, this.foregroundColor];
			
			this.graphics.beginGradientFill(fillType, newColors, alphas, ratios, matr);
			
			for(var i:int=0; i<this.periods.length; ++i)
			{
				var obj:Object = this.periods[i];
				this.graphics.drawRect(this.getXByTime(obj.startTime), 10, this.calcPeriodLen(obj), this.height-10 - 20);
			}			
			this.graphics.endFill();
		}
		
		//设置底部运行状态指示条
		private function setRunningStatusBarsByPeriods():void
		{
			if(this.periods == null) return;

			for each(var dispObj:DisplayObject in this.getChildren())
			{
				if(dispObj is RunningStatusBar)
				{
					this.removeChild(dispObj);
				}
			}
			
			for(var i:int=0; i<this.periods.length; ++i)
			{
				var obj:Object = this.periods[i];
				var bar:RunningStatusBar = new RunningStatusBar(this.calcPeriodLen(obj), this.foregroundColor);
				bar.x = this.getXByTime(obj.startTime);
				this.addChild(bar);
			}
		}
	
		//画背景色、底部运行状态条、刻度线、以及添加时间文本
		private function draw():void
		{
			this.graphics.clear();
			
			for each(var obj:DisplayObject in this.getChildren())
			{
				if(obj is UIComponent && obj.name == "clockNOBar")
				{
					this.removeChild(obj);
				}
			}
			
			this.setBGByPeriods();		//根据时间段属性画背景色块
			this.setRunningStatusBarsByPeriods();	//根据时间段属性设置底部的RunningStatusBar
			
			var uLenHour:Number = this.width / 24;
			var uLenMinute:Number = uLenHour / 4;

			this.graphics.lineStyle(1, 0x000000);
			
			var uiComp:UIComponent = new UIComponent();
			uiComp.name = "clockNOBar";
			uiComp.width = this.maskLayer.width;
		
			this.addChild(uiComp);
				
			for(var i:int=0; i<=24; ++i)
			{
				this.graphics.moveTo(i*uLenHour, 0+10);
				this.graphics.lineTo(i*uLenHour, 8+10);
				
				this.graphics.moveTo(i*uLenHour, this.height - 20);
				this.graphics.lineTo(i*uLenHour, this.height-8 - 20);
				
 				var lbl:TextField = new TextField();
				lbl.text = i.toString();
				lbl.x = i*uLenHour - lbl.textWidth/2-1;
				lbl.y = 16;
				lbl.name = "clockNO"; 
				
				uiComp.addChild(lbl);
				
				for(var j:int=0; j<4&&i!=24; ++j)
				{
					this.graphics.moveTo(i*uLenHour+j*uLenMinute, 0+10);
					this.graphics.lineTo(i*uLenHour+j*uLenMinute, 4+10);
					
					this.graphics.moveTo(i*uLenHour+j*uLenMinute, this.height -20);
					this.graphics.lineTo(i*uLenHour+j*uLenMinute, this.height-4 - 20);
				}
			}
			this.setChildIndex(this.maskLayer, this.numChildren-1);
		}
		
	}
}
//消息提示框
class TipsDialog extends UIComponent
{
	private var _width:Number;
	private var _height:Number;

	private var tfTimePoint:TextField;					//时间点: 00:00
	private var tfTimeSpanAndStatus:TextField;	//00:00-12:30 待机/运行
		
	public function TipsDialog(width:Number, height:Number)
	{
		this._width = width;
		this._height = height;
		this.tfTimePoint = new TextField();
		this.tfTimePoint.text = "时间点: " + "00:00";
		this.tfTimePoint.x = 2;

		this.tfTimePoint.selectable = false;
		this.addChild(this.tfTimePoint);
		
		this.tfTimeSpanAndStatus = new TextField();
		
		this.tfTimeSpanAndStatus.text = "00:00-12:30 待机";
		this.tfTimeSpanAndStatus.x = 2;
		this.tfTimeSpanAndStatus.y = 12;
		this.tfTimeSpanAndStatus.selectable = false;
		this.addChild(this.tfTimeSpanAndStatus);
		this.width = this._width;
		this.height = this._height;
		
		this.draw();
	}
	
	public function setTips(timePoint:String, timeSpanAndStatus:String):void
	{
		this.tfTimePoint.text =  "时间点: " + timePoint;
		this.tfTimeSpanAndStatus.text = timeSpanAndStatus;
	}
	
	private function draw():void
	{		
		this.graphics.beginFill(0xFFFF99);
		
		this.graphics.lineStyle(1, 0x000000);
		this.graphics.moveTo(0, 0);
		this.graphics.lineTo(this._width, 0);
		this.graphics.lineTo(this._width, this._height - 5);
		
		this.graphics.lineTo(this._width/2+5, this._height - 5);
		
 		this.graphics.lineTo(this._width/2, this._height +5);
		this.graphics.lineTo(this._width/2, this._height -5);
		this.graphics.lineTo(0, this._height - 5); 
		this.graphics.lineTo(0, 0);
		
		this.graphics.endFill();
	}	
}
//底部时间段指示条
import mx.core.UIComponent;
import flash.text.TextField;

class RunningStatusBar extends UIComponent
{
	private var color:uint;
	
	public function RunningStatusBar(width:Number, color:uint=0x0000)
	{
		super();
		this.color = color;
		this.width = width;
		this.height = 16;
		this.y = 45;
		this.draw(); 
	}
	
	private function draw():void
	{
		var tf:TextField = new TextField();
		tf.text = "运行";
		tf.x = this.width/2 - tf.textWidth/2;
		tf.width = tf.textWidth*1.5;
		tf.textColor = this.color;
		this.addChild(tf);		 
		 
		this.graphics.lineStyle(1, this.color);		
		//画左箭头
		this.graphics.beginFill(this.color); 
		this.graphics.moveTo(0, this.height/2);
		this.graphics.lineTo(6, this.height/2 - 2);
		this.graphics.lineTo(6, this.height/2 + 2);
		this.graphics.lineTo(0, this.height/2);
		this.graphics.endFill();
		//画左直线
		this.graphics.moveTo(0, this.height/2);
		this.graphics.lineTo(this.width/2-tf.textWidth/2, this.height/2);		
		//画右箭头
		this.graphics.beginFill(this.color); 
		this.graphics.moveTo(this.width, this.height/2);
		this.graphics.lineTo(this.width-6, this.height/2 -2);
		this.graphics.lineTo(this.width-6, this.height/2 + 2);
		this.graphics.lineTo(this.width, this.height/2);
		this.graphics.endFill();
		//画右直线
		this.graphics.moveTo(this.width, this.height/2);
		this.graphics.lineTo(this.width/2 + tf.textWidth/2 + 3, this.height/2);
		//画左右竖线
		this.graphics.moveTo(0, 0);
		this.graphics.lineTo(0, this.height);
		this.graphics.moveTo(this.width, 0);
		this.graphics.lineTo(this.width, this.height);
	}		
}










